package dev.shadowsoffire.apotheosis.adventure.affix.salvaging;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import dev.shadowsoffire.apotheosis.Apoth;
import dev.shadowsoffire.placebo.cap.InternalItemHandler;
import net.minecraft.core.BlockPos;
import net.minecraft.core.Direction;
import net.minecraft.nbt.CompoundTag;
import net.minecraft.nbt.Tag;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraft.world.level.block.entity.BlockEntityType;
import net.minecraft.world.level.block.state.BlockState;
import net.minecraftforge.common.capabilities.Capability;
import net.minecraftforge.common.capabilities.ForgeCapabilities;
import net.minecraftforge.common.util.LazyOptional;

public class SalvagingTableTile extends BlockEntity {
  protected final InternalItemHandler output;
  
  protected final LazyOptional<SalvagingItemHandler> itemHandler;
  
  public SalvagingTableTile(BlockPos pPos, BlockState pBlockState) {
    super((BlockEntityType)Apoth.Tiles.SALVAGING_TABLE.get(), pPos, pBlockState);
    this.output = new InternalItemHandler(6);
    this.itemHandler = LazyOptional.of(() -> new SalvagingItemHandler(this));
  }
  
  public <T> LazyOptional<T> getCapability(Capability<T> cap, Direction side) {
    if (cap == ForgeCapabilities.ITEM_HANDLER)
      return this.itemHandler.cast(); 
    return super.getCapability(cap, side);
  }
  
  protected void m_183515_(CompoundTag tag) {
    tag.m_128365_("output", (Tag)this.output.serializeNBT());
    super.m_183515_(tag);
  }
  
  public void m_142466_(CompoundTag tag) {
    if (tag.m_128441_("output"))
      this.output.deserializeNBT(tag.m_128469_("output")); 
    super.m_142466_(tag);
  }
}
